//
//  CHArrayExtensions.h
//  Chocolat
//
//  Created by Pieter Omvlee on 4/19/08.
//  Copyright 2008 Bohemian Coding. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSArray (CHArrayExtensions)

- (NSIndexSet *)indexesOfObjects:(NSArray *)array;

- (NSArray *)reversedArray;

- (BOOL)containsMemberOfClass:(Class)aClass;
- (BOOL)containsObjectOfClass:(Class)aClass;
- (BOOL)containsObjectFromArray:(NSArray *)anArray;
- (BOOL)containsOnlyObjectsOfClass:(Class)aClass;
- (BOOL)containsSingleClass;
- (BOOL)containsEqualObjects;

- (NSArray *)arrayWithOnlyObjectsOfClass:(Class)aClass;

- (NSArray *)map:(SEL)sel;
- (NSArray *)map:(SEL)sel withObject:(id)obj;
- (NSArray *)map:(SEL)sel withObject:(id)obj1 withObject:(id)obj2;

- (id)deepCopy;
- (id)mutableDeepCopy;

- (void)performSelector:(SEL)sel withEachObjectAsArgumentToTarget:(id)target;

- (NSArray *)sortedArray;
- (NSArray *)sortedArrayUsingKey:(NSString *)key;
- (NSArray *)sortedArrayUsingKeys:(NSArray *)keys;
- (NSArray *)arrayByRemovingObject:(id)anObject;

- (NSDictionary *)dictionaryBySplittingArrayUsingKey:(NSString *)aKey;
- (NSDictionary *)asDictionaryWithKeyForKey:(NSString *)aKey;

+ (NSArray *)arrayByMergingArrays:(NSArray *)array;

- (BOOL)isValidIndex:(int)anIndex;

- (NSArray *)subarrayFromIndex:(NSInteger)anIndex;

@end

@interface NSMutableArray (NSMutableArrayAdditions)
- (void)addObjectIfNotNil:(id)obj;
- (void)removeFirstObject;
- (void)insertObjectsFromArray:(NSArray *)array atIndex:(int)index;
- (void)onlyKeepObjectsFromClass:(Class)aClass;
@end