//
//  CHStringExtensions.h
//  POBase
//
//  Created by Pieter Omvlee on 3/9/08.
//  Copyright 2008 Bohemian Coding. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSString (CHStringExtensions)
+ (NSString *)stringWithPathComponents:(NSArray *)comps;
- (NSString *)stringByPrefixingIfNessary:(NSString *)aString;
- (NSString *)stringByDeletingPrefix:(NSString *)prefix;
- (NSString *)stringByDeletingSuffix:(NSString *)suffix;

- (BOOL)startsWith:(NSString *)str;
- (BOOL)endsWith:(NSString *)str;

@end

@interface NSString (CHStringPathExtensions)
- (NSString *)parent;
- (NSString *)child:(NSString *)childName;
- (NSString *)lastChild;
- (NSString *)extension;
- (NSString *)withoutExtension;
- (NSString *)withExtension:(NSString *)extension;
- (NSString *)expandTilde;
@end
